import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React from 'react';
import Collapse from './Collapse';
import { useBootstrapPrefix, useClassNameMapper } from './ThemeProvider';
import NavbarContext from './NavbarContext';
var NavbarCollapse = React.forwardRef(function (_ref, ref) {
  var children = _ref.children,
      bsPrefix = _ref.bsPrefix,
      classNameMap = _ref.classNameMap,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "bsPrefix", "classNameMap"]);

  bsPrefix = useBootstrapPrefix(bsPrefix, 'navbar-collapse');
  var classNames = useClassNameMapper(classNameMap);
  return React.createElement(NavbarContext.Consumer, null, function (context) {
    return React.createElement(Collapse, _extends({
      in: !!(context && context.expanded)
    }, props), React.createElement("div", {
      ref: ref,
      className: classNames(bsPrefix)
    }, children));
  });
});
NavbarCollapse.displayName = 'NavbarCollapse';
export default NavbarCollapse;